<template>
  <v-col>
    <v-col class="mb-2">
      <v-row align="end">
        <v-btn v-if="$vuetify.breakpoint.smAndUp && !seleccionable" color="accent" @click="abrirForm">
          <v-icon left>
            fal fa-user-plus
          </v-icon>
          Nuevo cliente
        </v-btn>
        <v-spacer v-if="$vuetify.breakpoint.smAndUp" />
        <v-text-field
          v-model="search"
          append-icon="fal fa-search"
          label="Buscar"
          single-line
          color="accent"
          hide-details
          :style="$vuetify.breakpoint.smAndDown ? 'display: block' : 'max-width: 40vh'"
        />
      </v-row>
    </v-col>
    <v-data-table
      ref="tabla"
      v-model="selected"
      :items-per-page="seleccionable ? 5 : 10"
      :headers="seleccionable ? ($vuetify.breakpoint.mdAndDown ? headersCelularSeleccionable : headersSeleccionable) : ($vuetify.breakpoint.mdAndDown ? headersCelular : headers) "
      :items="clientes"
      :search="search"
      class="elevation-1"
      item-key="idclientes"
      :show-select="seleccionable"
      single-select
      @item-selected="enviarSeleccionado()"
    >
      <template #[`item.action`]="{ item }">
        <v-btn
          color="accent"
          small
          outlined

          @click="abrirDetalle(item)"
        >
          Detalle
        </v-btn>
      </template>
      <template v-if="!seleccionable" #[`item.icons`]="{ item }">
        <v-icon
          small
          class="mr-2 fal fa-edit"
          @click="modificarCliente(item)"
        />
        <v-icon
          small
          class="fal fa-trash-alt"
          @click="eliminarCliente(item.idclientes)"
        />
      </template>
    </v-data-table>

    <v-dialog v-model="dialogDetalle" width="700" :fullscreen="$vuetify.breakpoint.smAndDown">
      <detalle-cliente v-if="dialogDetalle" :cliente="clienteActual" @onClose="cerrarDialog" />
    </v-dialog>
  </v-col>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue } from 'vue-property-decorator'
import AppToast from '~/core/utils/AppToast'
import { Cliente } from '~/core/models/cliente'
import { ClientesStore } from '~/store/ClientesStore'
import DetalleCliente from '~/components/clientes/detalleCliente.vue'
    @Component({
      components: { DetalleCliente },
      name: 'lista-clientes'
    })
export default class listaClientes extends Vue {
        @Ref() tabla;
        @Prop({ default: false }) seleccionable!:boolean;
        @Prop({ default: null }) clienteSeleccionado!:Cliente;

        selected:Cliente[] = [];
        search = '';
        cliente:Cliente = null;
        dialogDetalle:boolean = false;
        clienteActual:Cliente = null;

        headersSeleccionable = [
          { text: 'Seleccione', align: 'left', value: 'data-table-select' },
          { text: 'ID', align: 'left', value: 'idclientes' },
          { text: 'Nombre', align: 'left', value: 'nombre' },
          { text: 'DNI', align: 'left', value: 'dni' },
          { value: 'icons', align: 'right', sortable: false, width: 80 }

        ];

        headers = [
          { text: 'ID', align: 'left', value: 'idclientes' },
          { text: 'Nombre', align: 'left', value: 'nombre' },
          { text: 'DNI', align: 'left', value: 'dni' },
          { text: 'Teléfono', align: 'left', value: 'telefono' },
          { text: 'Dirección', align: 'left', value: 'direccion' },
          { text: 'E-mail', align: 'left', value: 'email' },
          { value: this.seleccionable ? 'asd' : 'action', align: 'right', sortable: false },
          { value: 'icons', align: 'right', sortable: false, width: 80 }
        ];

      headersCelularSeleccionable = [
        { text: 'Seleccione', align: 'left', value: 'data-table-select' },
        { text: 'ID', align: 'left', value: 'idclientes' },
        { text: 'Nombre', align: 'left', value: 'nombre' },
        { text: 'DNI', align: 'left', value: 'dni' },
        { text: 'Teléfono', align: 'left', value: 'telefono' },
        { text: 'Dirección', align: 'left', value: 'direccion' },
        { value: 'action', align: 'right', sortable: false },
        { value: 'icons', align: 'right', sortable: false, width: 80 }
      ];

      headersCelular = [
        { text: 'Nombre', align: 'left', value: 'nombre' },
        { text: 'DNI', align: 'left', value: 'dni' },
        { value: 'action', align: 'right', sortable: false },
        { value: 'icons', align: 'right', sortable: false, width: 80 }
      ];

      get clientes ():Cliente[] {
        return ClientesStore.listaClientes
      }

      mounted () {
        if (this.clienteSeleccionado === null) {
          this.selected = []
        } else { this.selected.push(this.clienteSeleccionado) }
      }

      modificarCliente (val) {
        this.$emit('onEdit', val)
      }

      eliminarCliente (id:number) {
        this.$confirm('¿Está seguro?').then(async (res) => {
          if (res) {
            await ClientesStore.eliminarCliente(id)
            AppToast.info('Cliente eliminado')
          }
        }).catch()
      }

      enviarSeleccionado () {
        setTimeout(() => {
          this.$emit('selectedCliente', this.selected[0])
        }, 300)
      }

      abrirDetalle (cliente) {
        this.clienteActual = cliente
        this.dialogDetalle = true
      }

      abrirForm () {
        this.$emit('onAbrir')
      }

      cerrarDialog () {
        this.clienteActual = null
        this.dialogDetalle = false
      }
}
</script>

<style lang="scss">
</style>
